package uniandes.cupi2.mundopokemon.mundo;

/**
 * Clase que representa un pokemon
 * @author alvar-go
 */
public class Pokemon extends ElementoJerarquia{

	/**
	 * El nmero del pokemon
	 */
	private String numero;
	
	/**
	 * Crea un pokemon a partir de su nombre y nmero
	 * @param nom el nombre del pokemon. nom != null
	 * @param num el nmero del pojemon. num != num
	 */
	public Pokemon(String nom, String num)
	{
		super(nom, TipoElementoJerarquia.POKEMON);
		numero = num;
	}
	
	/**
	 * Da el nombre del pokemon
	 * @return nombre
	 */
	public String darNombre()
	{
		return nombre;
	}
	
	/**
	 * Da la imagen del pokemon
	 * @return numero + " " + nombre + ".png"
	 */
	public String darImagen()
	{
		
		return numero + " " + nombre+".png";
	}
	
	/**
	 * Da el nmero del pokemon
	 * @return nmero
	 */
	public String darNumero()
	{
		return numero;
	}
}
